unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  LCLIntf, LCLType, cairo, cairo_win32;

type

  { TForm1 }

  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
    hh,mm,ss,ms,ls: Word;
    procedure PaintClock;
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  Form1.Caption := 'Clock ' + lowerCase({$I %FPCTARGETCPU%}) + '-' + lowerCase({$I %FPCTARGETOS%}) + ' - Cairo ' + String( Pchar( cairo_version_string() ));

  DecodeTime(Now,hh,mm,ss,ms);
  ls := ss;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
  PaintClock;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  DecodeTime(Now,hh,mm,ss,ms);

  // No stress
  if ls <> ss then
  begin
    ls := ss;
    PaintClock;
  end;
end;

procedure TForm1.PaintClock;
var
  size: Integer;
  surface: Pcairo_surface_t;
  cairo: Pcairo_t;
  h,m,s: Double;
begin
  if PaintBox1.Height < PaintBox1.Width then
    size := PaintBox1.Height
  else
    size := PaintBox1.Width;

  h := (hh+mm/60)*pi/6;
  m := mm*pi/30;
  s := ss*pi/30;

  surface := cairo_win32_surface_create_with_dib(CAIRO_FORMAT_ARGB32,size,size);
  cairo := cairo_create(surface);
  cairo_scale(cairo,size,size);

  // Set line properties
  cairo_set_line_cap(cairo,CAIRO_LINE_CAP_ROUND);
  cairo_set_line_width(cairo,0.1);

  // Translate to the center of the rendering context
  cairo_translate(cairo,0.5,0.5);

  // Draw the context white
  cairo_set_source_rgba(cairo,1,1,1,1);
  cairo_arc(cairo,0,0,0.4,0,pi*2);
  cairo_fill(cairo);

  // Draw a black clock outline
  cairo_set_source_rgba(cairo,0,0,0,1);
  cairo_arc(cairo,0,0,0.4,0,pi*2);
  cairo_stroke(cairo);

  // Draw a white dot on the current second
  cairo_set_source_rgba(cairo,1,1,1,0.6);
  cairo_arc(cairo,Sin(s)*0.4,-Cos(s)*0.4,0.05,0,pi*2);
  cairo_fill(cairo);

  // Draw the minutes indicator
  cairo_set_source_rgba(cairo,0.2,0.2,1,0.6);
  cairo_move_to(cairo,0, 0);
  cairo_line_to(cairo,Sin(m)*0.4,-Cos(m)*0.4);
  cairo_stroke(cairo);

  // Draw the hours indicator
  cairo_move_to(cairo,0,0);
  cairo_line_to(cairo,Sin(h)*0.2,-Cos(h)*0.2);
  cairo_stroke(cairo);

  cairo_destroy(cairo);
  BitBlt(PaintBox1.Canvas.Handle,(PaintBox1.Width - size) div 2,(PaintBox1.Height - size) div 2,size,size,cairo_win32_surface_get_dc(surface),0,0,SRCCOPY);
  cairo_surface_destroy(surface);
end;

end.

